// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_uss_msgs:msg/DirectEcho.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHO__STRUCT_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'first'
// Member 'first_filtered'
// Member 'second'
#include "off_highway_uss_msgs/msg/detail/echo__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_uss_msgs__msg__DirectEcho __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_uss_msgs__msg__DirectEcho __declspec(deprecated)
#endif

namespace off_highway_uss_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DirectEcho_
{
  using Type = DirectEcho_<ContainerAllocator>;

  explicit DirectEcho_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    first(_init),
    first_filtered(_init),
    second(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
    }
  }

  explicit DirectEcho_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    first(_alloc, _init),
    first_filtered(_alloc, _init),
    second(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    uint8_t;
  _id_type id;
  using _first_type =
    off_highway_uss_msgs::msg::Echo_<ContainerAllocator>;
  _first_type first;
  using _first_filtered_type =
    off_highway_uss_msgs::msg::Echo_<ContainerAllocator>;
  _first_filtered_type first_filtered;
  using _second_type =
    off_highway_uss_msgs::msg::Echo_<ContainerAllocator>;
  _second_type second;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const uint8_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__first(
    const off_highway_uss_msgs::msg::Echo_<ContainerAllocator> & _arg)
  {
    this->first = _arg;
    return *this;
  }
  Type & set__first_filtered(
    const off_highway_uss_msgs::msg::Echo_<ContainerAllocator> & _arg)
  {
    this->first_filtered = _arg;
    return *this;
  }
  Type & set__second(
    const off_highway_uss_msgs::msg::Echo_<ContainerAllocator> & _arg)
  {
    this->second = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_uss_msgs__msg__DirectEcho
    std::shared_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_uss_msgs__msg__DirectEcho
    std::shared_ptr<off_highway_uss_msgs::msg::DirectEcho_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DirectEcho_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->first != other.first) {
      return false;
    }
    if (this->first_filtered != other.first_filtered) {
      return false;
    }
    if (this->second != other.second) {
      return false;
    }
    return true;
  }
  bool operator!=(const DirectEcho_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DirectEcho_

// alias to use template instance with default allocator
using DirectEcho =
  off_highway_uss_msgs::msg::DirectEcho_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace off_highway_uss_msgs

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHO__STRUCT_HPP_
