// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_uss_msgs:msg/Echo.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__ECHO__TRAITS_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__ECHO__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_uss_msgs/msg/detail/echo__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace off_highway_uss_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Echo & msg,
  std::ostream & out)
{
  out << "{";
  // member: amplitude
  {
    out << "amplitude: ";
    rosidl_generator_traits::value_to_yaml(msg.amplitude, out);
    out << ", ";
  }

  // member: distance
  {
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Echo & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: amplitude
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "amplitude: ";
    rosidl_generator_traits::value_to_yaml(msg.amplitude, out);
    out << "\n";
  }

  // member: distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "distance: ";
    rosidl_generator_traits::value_to_yaml(msg.distance, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Echo & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_uss_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_uss_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_uss_msgs::msg::Echo & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_uss_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_uss_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_uss_msgs::msg::Echo & msg)
{
  return off_highway_uss_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_uss_msgs::msg::Echo>()
{
  return "off_highway_uss_msgs::msg::Echo";
}

template<>
inline const char * name<off_highway_uss_msgs::msg::Echo>()
{
  return "off_highway_uss_msgs/msg/Echo";
}

template<>
struct has_fixed_size<off_highway_uss_msgs::msg::Echo>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<off_highway_uss_msgs::msg::Echo>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<off_highway_uss_msgs::msg::Echo>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__ECHO__TRAITS_HPP_
