// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_uss_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_uss_msgs/msg/detail/object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'position_first'
// Member 'position_second'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace off_highway_uss_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Object & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: position_first
  {
    out << "position_first: ";
    to_flow_style_yaml(msg.position_first, out);
    out << ", ";
  }

  // member: exist_probability
  {
    out << "exist_probability: ";
    rosidl_generator_traits::value_to_yaml(msg.exist_probability, out);
    out << ", ";
  }

  // member: position_second
  {
    out << "position_second: ";
    to_flow_style_yaml(msg.position_second, out);
    out << ", ";
  }

  // member: object_type
  {
    out << "object_type: ";
    rosidl_generator_traits::value_to_yaml(msg.object_type, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: position_first
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_first:\n";
    to_block_style_yaml(msg.position_first, out, indentation + 2);
  }

  // member: exist_probability
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "exist_probability: ";
    rosidl_generator_traits::value_to_yaml(msg.exist_probability, out);
    out << "\n";
  }

  // member: position_second
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "position_second:\n";
    to_block_style_yaml(msg.position_second, out, indentation + 2);
  }

  // member: object_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_type: ";
    rosidl_generator_traits::value_to_yaml(msg.object_type, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Object & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_uss_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_uss_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_uss_msgs::msg::Object & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_uss_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_uss_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_uss_msgs::msg::Object & msg)
{
  return off_highway_uss_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_uss_msgs::msg::Object>()
{
  return "off_highway_uss_msgs::msg::Object";
}

template<>
inline const char * name<off_highway_uss_msgs::msg::Object>()
{
  return "off_highway_uss_msgs/msg/Object";
}

template<>
struct has_fixed_size<off_highway_uss_msgs::msg::Object>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Point>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_uss_msgs::msg::Object>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Point>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_uss_msgs::msg::Object>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__OBJECT__TRAITS_HPP_
