// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_uss_msgs:msg/Echo.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__ECHO__STRUCT_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__ECHO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__off_highway_uss_msgs__msg__Echo __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_uss_msgs__msg__Echo __declspec(deprecated)
#endif

namespace off_highway_uss_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Echo_
{
  using Type = Echo_<ContainerAllocator>;

  explicit Echo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->amplitude = 0;
      this->distance = 0;
    }
  }

  explicit Echo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->amplitude = 0;
      this->distance = 0;
    }
  }

  // field types and members
  using _amplitude_type =
    uint8_t;
  _amplitude_type amplitude;
  using _distance_type =
    uint16_t;
  _distance_type distance;

  // setters for named parameter idiom
  Type & set__amplitude(
    const uint8_t & _arg)
  {
    this->amplitude = _arg;
    return *this;
  }
  Type & set__distance(
    const uint16_t & _arg)
  {
    this->distance = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t AMPLITUDE_NO_OBJECT =
    63u;
  static constexpr uint8_t AMPLITUDE_SNA =
    64u;
  static constexpr uint16_t DISTANCE_SNA =
    1023u;
  static constexpr uint16_t DISTANCE_SENSOR_FAULTED =
    1022u;
  static constexpr uint16_t DISTANCE_SENSOR_BLIND =
    1021u;
  static constexpr uint16_t DISTANCE_PRESENCE_DETECTION =
    1002u;
  static constexpr uint16_t DISTANCE_NO_OBJECT =
    1003u;

  // pointer types
  using RawPtr =
    off_highway_uss_msgs::msg::Echo_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_uss_msgs::msg::Echo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::Echo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::Echo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_uss_msgs__msg__Echo
    std::shared_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_uss_msgs__msg__Echo
    std::shared_ptr<off_highway_uss_msgs::msg::Echo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Echo_ & other) const
  {
    if (this->amplitude != other.amplitude) {
      return false;
    }
    if (this->distance != other.distance) {
      return false;
    }
    return true;
  }
  bool operator!=(const Echo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Echo_

// alias to use template instance with default allocator
using Echo =
  off_highway_uss_msgs::msg::Echo_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Echo_<ContainerAllocator>::AMPLITUDE_NO_OBJECT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Echo_<ContainerAllocator>::AMPLITUDE_SNA;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Echo_<ContainerAllocator>::DISTANCE_SNA;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Echo_<ContainerAllocator>::DISTANCE_SENSOR_FAULTED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Echo_<ContainerAllocator>::DISTANCE_SENSOR_BLIND;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Echo_<ContainerAllocator>::DISTANCE_PRESENCE_DETECTION;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t Echo_<ContainerAllocator>::DISTANCE_NO_OBJECT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace off_highway_uss_msgs

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__ECHO__STRUCT_HPP_
