// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from off_highway_uss_msgs:msg/Object.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'position_first'
// Member 'position_second'
#include "geometry_msgs/msg/detail/point__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__off_highway_uss_msgs__msg__Object __attribute__((deprecated))
#else
# define DEPRECATED__off_highway_uss_msgs__msg__Object __declspec(deprecated)
#endif

namespace off_highway_uss_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Object_
{
  using Type = Object_<ContainerAllocator>;

  explicit Object_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    position_first(_init),
    position_second(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
      this->exist_probability = 0.0;
      this->object_type = 0;
    }
  }

  explicit Object_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    position_first(_alloc, _init),
    position_second(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
      this->exist_probability = 0.0;
      this->object_type = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    uint8_t;
  _id_type id;
  using _position_first_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_first_type position_first;
  using _exist_probability_type =
    double;
  _exist_probability_type exist_probability;
  using _position_second_type =
    geometry_msgs::msg::Point_<ContainerAllocator>;
  _position_second_type position_second;
  using _object_type_type =
    uint8_t;
  _object_type_type object_type;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const uint8_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__position_first(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position_first = _arg;
    return *this;
  }
  Type & set__exist_probability(
    const double & _arg)
  {
    this->exist_probability = _arg;
    return *this;
  }
  Type & set__position_second(
    const geometry_msgs::msg::Point_<ContainerAllocator> & _arg)
  {
    this->position_second = _arg;
    return *this;
  }
  Type & set__object_type(
    const uint8_t & _arg)
  {
    this->object_type = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t TYPE_NONE =
    0u;
  static constexpr uint8_t TYPE_POINT =
    1u;
  static constexpr uint8_t TYPE_LINE =
    2u;

  // pointer types
  using RawPtr =
    off_highway_uss_msgs::msg::Object_<ContainerAllocator> *;
  using ConstRawPtr =
    const off_highway_uss_msgs::msg::Object_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::Object_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      off_highway_uss_msgs::msg::Object_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__off_highway_uss_msgs__msg__Object
    std::shared_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__off_highway_uss_msgs__msg__Object
    std::shared_ptr<off_highway_uss_msgs::msg::Object_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Object_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->position_first != other.position_first) {
      return false;
    }
    if (this->exist_probability != other.exist_probability) {
      return false;
    }
    if (this->position_second != other.position_second) {
      return false;
    }
    if (this->object_type != other.object_type) {
      return false;
    }
    return true;
  }
  bool operator!=(const Object_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Object_

// alias to use template instance with default allocator
using Object =
  off_highway_uss_msgs::msg::Object_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Object_<ContainerAllocator>::TYPE_NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Object_<ContainerAllocator>::TYPE_POINT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t Object_<ContainerAllocator>::TYPE_LINE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace off_highway_uss_msgs

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__OBJECT__STRUCT_HPP_
